<?php

require_once 'config.php';

if ((!isset($dbtable_prefix)) || (empty($dbtable_prefix))) {
    $dbtable_prefix = 'Faucetinabox_';
}
if ((!isset($dbtable_shortlink_pool_prefix)) || (empty($dbtable_shortlink_pool_prefix))) {
    $dbtable_shortlink_pool_prefix = $dbtable_prefix;
}

$session_prefix=md5($dbuser.'-'.$dbname.'-'.$dbtable_prefix);
$session_prefix='_'.substr($session_prefix, 0, 8);

session_start();
header('Content-Type: text/html; charset=utf-8');
ini_set('display_errors', false);

if (empty($_SESSION['shortlink'.$session_prefix]['hash'])) {
    header('X-Error: Missing hash.');
    header('Location: .');
    exit;
}

// returning from a shortlink
if (!empty($_GET['sl'])) {
    if ($_GET['sl']==$_SESSION['shortlink'.$session_prefix]['hash']) {
        // success, redirect to home
        $_SESSION['shortlink'.$session_prefix]['solved']=true;
        header('Location: .');
        exit;
    }
    // bad shortlink hash
    header('X-Error: Returning. Bad shortlink hash.');
    header('Location: .');
    exit;
}

if ((!empty($_GET['h']))&&(!empty($_SESSION['shortlink'.$session_prefix]['hash']))&&($_SESSION['shortlink'.$session_prefix]['jmp'])==$_GET['h']) {
    // allow link generation
} else {
    // redirect to home
    header('X-Error: Bad jmp value.');
    header('Location: .');
    exit;
}

// generate shortlink
include_once 'libs/functions.php';

// generate new shortlink
try {
    $sql = new PDO($dbdsn, $dbuser, $dbpass, array(PDO::ATTR_PERSISTENT => true, PDO::ATTR_ERRMODE => PDO::ERRMODE_EXCEPTION));
} catch(PDOException $e) {
    header('X-Error: No SQL connection.');
    header('Location: .');
    exit;
}

// check if configured
try {
    // load settings
    $faucet_settings_array=fb_load_settings();
    if (empty($faucet_settings_array['password'])) {
        // not configured
        exit;
    }
} catch(PDOException $e) {
    // not installed
    exit;
}

$shortlink_data=$_SESSION['shortlink'.$session_prefix]['shortlink_data'];
// check used once again
$used_shortlinks = array();
$q = $sql->prepare("SELECT
                     shortlink,
                     count(id) AS countclaims
                    FROM ".$dbtable_shortlink_pool_prefix."Claimlog
                    WHERE
                     ip LIKE ?
                    AND
                     time>=?
                    GROUP BY shortlink;");
$q->execute(array(getIP(), time()-86400));
while ($item = $q->fetch(PDO::FETCH_ASSOC)) {
    $used_shortlinks[$item['shortlink']] = $item['countclaims'];
}
foreach ($shortlink_data as $shortlink_id => $v) {
    // remove used
    if (!empty($used_shortlinks[$shortlink_id])) {
        if ((!empty($v['limit'])) && ($v['limit']>0) && ($used_shortlinks[$shortlink_id]>=$v['limit'])) {
            unset($shortlink_data[$shortlink_id]);
            continue;
        }
        $shortlink_data[$shortlink_id]['used']=$used_shortlinks[$shortlink_id];
    }
}

// sort shortlink data using priority
uasort($shortlink_data, 'sort_shortlink_data');
/*
echo '<pre>';
print_r($shortlink_data);
echo '</pre>';
exit;
*/
foreach ($shortlink_data as $key => $val) {
    // get random key
    $api_token = $_SESSION['shortlink'.$session_prefix]['shortlink_data'][$key]['apikey'];
    $api_url = $_SESSION['shortlink'.$session_prefix]['shortlink_data'][$key]['apilink'];

    // Check protocol
    if (is_ssl()) {
        $protocol = "https://";
    } else {
        $protocol = "http://";
    }
    //
    $return_url = $protocol.$_SERVER['HTTP_HOST'].strtok($_SERVER['REQUEST_URI'], '?').'?sl='.$_SESSION['shortlink'.$session_prefix]['hash'];
    $return_url_encoded = urlencode($return_url);

    $ch = curl_init();
    if ($ch === false) {
        // curl not enabled
        header('X-Error: Curl not enabled.');
        header('Location: .');
        exit;
    }
    switch ($key) {
        case '1ink':
            $api_token_array = explode('-', $api_token, 2);
            if (count($api_token_array)<2) {
                header('X-Error-'.$key.': '.$key.' fail');
                continue;
            }
            $api_url = str_replace('#uid#', $api_token_array[0], $api_url);
            $api_url = str_replace('#uname#', $api_token_array[1], $api_url);
            $api_url = str_replace('#url#', $return_url_encoded, $api_url);
            // get the shortlink
            curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 7);
            curl_setopt($ch, CURLOPT_TIMEOUT, 7);
            curl_setopt($ch, CURLOPT_URL, $api_url);
            curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
            curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
            curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, false);
            curl_setopt($ch, CURLOPT_FOLLOWLOCATION, true);
            $shortlink_response = @curl_exec($ch);
            curl_close($ch);
            if (!empty($shortlink_response)) {
                // valid shortlink - go
                $_SESSION['shortlink'.$session_prefix]['used'] = $key;
                $_SESSION['shortlink'.$session_prefix]['used_url'] = 'http://1ink.cc/'.$shortlink_response;
                header('Location: http://1ink.cc/'.$shortlink_response);
                exit;
            } else {
                // bad shortlink
                header('X-Error-'.$key.': '.$key.' fail');
                continue;
            }
        break;
        case 'shorte':
            //curl -H "public-api-token: API" -X PUT -d "urlToShorten=google.com" https://api.shorte.st/v1/data/url
            curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 7);
            curl_setopt($ch, CURLOPT_TIMEOUT, 7);
            curl_setopt($ch, CURLOPT_URL, $api_url);
            curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
            curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
            curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, false);
            curl_setopt($ch, CURLOPT_FOLLOWLOCATION, true);
            curl_setopt($ch, CURLOPT_HTTPHEADER, array('public-api-token: '.$api_token));
            curl_setopt($ch, CURLOPT_CUSTOMREQUEST, 'PUT');
            curl_setopt($ch, CURLOPT_POSTFIELDS, 'urlToShorten='.$return_url_encoded);
            $shortlink_response = @curl_exec($ch);
            curl_close($ch);
            $result = @json_decode($shortlink_response, true);
            if ((!empty($result['status'])) && ($result['status']=='ok')) {
                // valid shortlink - go
                $_SESSION['shortlink'.$session_prefix]['used'] = $key;
                $_SESSION['shortlink'.$session_prefix]['used_url'] = $result['shortenedUrl'];
                header('Location: '.$result['shortenedUrl']);
                exit;
            } else {
                // bad shortlink
                header('X-Error-'.$key.': '.$key.' fail');
                continue;
            }
        break;
        default:
            $api_url.= '?api='.$api_token.'&url='.$return_url_encoded.'&alias=FBu'.randHash(9).'&expiry='.(time()+10800);//.'&type=1'
            // get the shortlink
            curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 7);
            curl_setopt($ch, CURLOPT_TIMEOUT, 7);
            curl_setopt($ch, CURLOPT_URL, $api_url);
            curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
            curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
            curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, false);
            curl_setopt($ch, CURLOPT_FOLLOWLOCATION, true);
            $shortlink_response = @curl_exec($ch);
            curl_close($ch);
            // not compatible with http: api - retry with https:
            if (empty($shortlink_response)) {
                $http_pos=stripos($api_url, 'http://');
                if (($http_pos!==false) && ($http_pos==0))  {
                    if ($ch = curl_init()) {
                        curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 7);
                        curl_setopt($ch, CURLOPT_TIMEOUT, 7);
                        curl_setopt($ch, CURLOPT_URL, 'https://'.substr($api_url, 7));
                        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
                        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
                        curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, false);
                        curl_setopt($ch, CURLOPT_FOLLOWLOCATION, true);
                        $shortlink_response = @curl_exec($ch);
                        curl_close($ch);
                    }
                }
            }
            $result = @json_decode($shortlink_response, true);
            if ((!empty($result['status'])) && ($result['status']=='success')) {
                // valid shortlink - go
                $_SESSION['shortlink'.$session_prefix]['used'] = $key;
                $_SESSION['shortlink'.$session_prefix]['used_url'] = $result['shortenedUrl'];
                header('Location: '.$result['shortenedUrl']);
                exit;
            } else {
                // bad shortlink
                header('X-Error-'.$key.': '.$key.' fail');
                continue;
            }
        break;
    }
}

// error - No link provider available, redirect to home
$_SESSION['shortlink'.$session_prefix]['enabled'] = false;
$_SESSION['shortlink'.$session_prefix]['time'] = time();
header('X-Error-final: No link provider available.');
header('Location: .');
exit;

?>